/* Demo for scaling forms. */

#include <stdlib.h>
#include <stdio.h>
#include "forms.h"

FL_FORM *form;

FL_OBJECT
        *smallerobj,
        *largerobj,
        *scaleobj,
        *exitobj;

void create_form_form(void)
{
  FL_OBJECT *obj;
  form = fl_bgn_form(FL_NO_BOX,470.0,370.0);
  obj = fl_add_box(FL_UP_BOX,0.0,0.0,470.0,370.0,"");
  obj = fl_add_box(FL_SHADOW_BOX,30.0,270.0,410.0,70.0,"Scaling Forms");
    fl_set_object_color(obj,9,47);
    fl_set_object_lsize(obj,16.000000);
  smallerobj = obj = fl_add_button(FL_NORMAL_BUTTON,30.0,110.0,130.0,40.0,"Smaller");
  largerobj = obj = fl_add_button(FL_NORMAL_BUTTON,310.0,110.0,130.0,40.0,"Larger");
  scaleobj = obj = fl_add_input(FL_FLOAT_INPUT,170.0,190.0,270.0,40.0,"Scale:");
  exitobj = obj = fl_add_button(FL_NORMAL_BUTTON,310.0,30.0,130.0,40.0,"Exit");
  fl_end_form();
}

/*---------------------------------------*/

void create_the_forms(void)
{
  create_form_form();
}


main()
{
    float sc = 1.0, oldsc;
    FL_OBJECT *obj;
    char str[32];
    create_the_forms();
    sprintf(str, "%.2f", sc);
    fl_set_input(scaleobj, str);
    fl_show_form(form, FL_PLACE_CENTER, FALSE, "Scaling");
    while (1)
    {
	oldsc = sc;
	obj = fl_do_forms();
	if (obj == exitobj) exit(0);
	if (obj == smallerobj) sc = sc*0.8;
	if (obj == largerobj) sc = sc*(1.0/0.8);
	if (obj == scaleobj) sc = atof(fl_get_input(scaleobj));
	if (sc<0.15) sc = 0.15;
	if (sc>3.0) sc = 3.0;
	if (sc != oldsc)
	{
	    fl_scale_form(form, sc/oldsc, sc/oldsc);
	    sprintf(str, "%.2f", sc);
	    fl_set_input(scaleobj, str);
	}
    }
}
